#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels
// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
//#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
//Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT);

void display_volume() {
    // do nothing
}

void display_keypress(int keyNumber) {
    // do nothing    
}

// this in not used as yet...
void display_ptt_state(bool flag) {
    display.setCursor(100,0);
    if (flag) { 
        display.print("PTT");
    } else { 
        display.print("   ");
    }
    display.display(); // Update screen
}


void setup_display() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  display.display();                  // Update screen
  display.setTextSize(1);             // Normal 1:1 pixel scale
  display.setTextColor(WHITE,BLACK);  // Draw white text
  display.setCursor(0,0);             // Start at top-left corner
  display.println(F(Version));
  display.display(); // Update screen
  delay(1000);
  display.clearDisplay();
  display.display(); // Update screen
}

/********************************
  update frequency and step-size
********************************/
void display_freq_step() {
     updateFlag = LOW;
   long MHz = frequency/1000000;

   // convert frequency to floating point
   // adding 0.0000001 fixes a rounding error
   double freq = (double) frequency/1000000+0.0000001;

   // display frequency

 //     display.setTextColor(WHITE,BLACK);         // Normal Frequ Display 

      display.setCursor(20,0);                         // start at char 1, line 1 (5,0)
       if (last_sideband==0)
       { display.print("AM ");
       }
       else
      if (last_sideband==1)
       { display.print("USB");
       }
      if (last_sideband==2)
       { display.print("LSB");
       }

 if (TRXmode != RX)
  { display.setTextColor(BLACK,WHITE);         // Invert Frequ Display  
  }
 else 
  {display.setTextColor(WHITE,BLACK);         // Normal Frequ Display 
  }      
     display.setTextSize(2);
 if (MHz < 10) 
  {display.setCursor(24,10);                          // start at char 1, line 1
   display.print(freq, 5);                          // 5 digit resolution
  }else 
    {display.setCursor(12,10);                          // start at char 1, line 1 (10,10)
     display.print(freq, 5);
    }
  display.setTextSize(0);
  display.print("MHz");
  display.display(); // Update screen

  display.setTextColor(WHITE,BLACK);         // Normal Frequ Display     
  display.display(); // Update screen

  display.setCursor(0,25);                          // start at char 1, line 2
  display.print("                    ");   
  display.display(); // Update screen
  
  // display step size
   switch (step_size) {
      
 /*      case 1:                                  // added for 1xHz.
       display.setCursor(99,25);
       display.print("*");
       break;
*/
     case 10:
       display.setCursor(99,25);
       display.print("*");
       break;
     case 100:
       display.setCursor(87,25);
       display.print("*");
       break;
     case 1000:
       display.setCursor(75,25);
       display.print("*");
       break;
     case 10000:
       display.setCursor(63,25);
       display.print("*");
       break;
     case 100000:
       display.setCursor(51,25);
       display.print("*");
       break;
     default:
       break;
   }
   display.display();
}

void displayRIT()
{  display.setCursor(100,0);
  if (lastRIT <= 10)
   { display.print("PTT");
   }
  else 
  { if (lastRIT <100)
    {  display.print(" ");
    }
    else
      { display.print(lastRIT);
      }
  }
  display.display(); // Update screen
}
